LeetCode OJ - Two Sum

来源:互联网 发布:大道寺知世和知世公主 编辑:程序博客网 时间:2024/05/16 11:48

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9

Output: index1=1, index2=2


my answer:

public class Solution {    public int[] twoSum(int[] nums, int target) {    int[] res = new int[2];    for(int x=0;x<nums.length;x++){    for(int y=x+1;y<nums.length;y++){        if (nums[x] + nums[y] == target){    res[0] = x+1;     res[1] = y+1; return res;    }       }    }              return null;    }}
Runtime: 41 ms

参考: http://blog.sina.com.cn/s/blog_7bee572b0101ux4q.html

改进如下:

public class Solution_1 {    public int[] twoSum(int[] numbers, int target) {        int[] res = new int[2];        HashMap<Integer,Integer> map = new HashMap<Integer,Integer>();        for(int i = 0; i < numbers.length; i++){            map.put(numbers[i], i);        }        for(int i = 0; i < numbers.length; i++){            int gap = target - numbers[i];            if(map.get(gap)!= null &&map.get(gap)!= i){                res[0] = i+1;                res[1] = map.get(gap) + 1;                break;            }        }    return res;    }}

Runtime: 8 ms


总结:暴力搜索,时间复杂度为O(n*n),很简单,但是会出现超时错误。

    利用HashMap,存储数组中的值和Index,由于HashMap中查询键值对的开销是固定的,因此在性能上可以得到很大的提升。

1 0
原创粉丝点击